﻿


@model OperationalRiskException.Core.ViewModels.AssessmentSchedulerVM
@{
    ViewBag.Title = "Assessment Scheduling";
    Layout = "~/Views/Shared/_LayoutProcessor.cshtml";
}



<div class="row">
    <div class="col-md-12 grid-margin">
        <div class="d-flex justify-content-between flex-wrap">
            <div class="d-flex align-items-end flex-wrap">
                <div class="d-flex">
                    <i class="mdi mdi-home text-muted hover-cursor"></i>
                    <p class="text-muted mb-0 hover-cursor">&nbsp;/&nbsp; Configuration Management &nbsp;/&nbsp;</p>
                    <p class="text-primary mb-0 hover-cursor">Assessment Scheduling</p>
                </div>
            </div>

        </div>
    </div>
</div>
<div class="row">
    <div class="col-md-12 grid-margin stretch-card">
        <div class="card">
            <div class="card-body">
                <h4 class="card-title"> Assessment </h4>
                <p class="card-description">
                    
                </p>

                @using (Html.BeginForm("Home", "AssessmentScheduling", FormMethod.Post, new { @class = "forms-sample", role = "form" }))
                {
                    @Html.AntiForgeryToken()

            <div class="row">
                @*<div class="form-group col-md-12">
                    <label for="exampleInputUsername1">Assessment Scheduling</label>
                    <div class="row col-md-12">
                        @Html.EditorFor(n => n.AssessmentSchedulerName, new { htmlAttributes = new { @class = "form-control", @placeholder = " Name" } })
                        @Html.ValidationMessageFor(model => model.AssessmentSchedulerName, null, new { @class = "text text-danger" })
                    </div>
                </div>*@

                <div class="form-group col-md-12">
                    <label for="exampleInputUsername1">Select Assessment Period</label>
                    <div class="row col-md-12">
                        @Html.DropDownListFor(n => n.AssessmentSetupId, Enumerable.Empty<SelectListItem>(), "Please select Question", new { @class = "form-control select2 col-md-12", @id = "select2" })
                        @Html.ValidationMessageFor(model => model.AssessmentSetupId, null, new { @class = "text text-danger" })
                    </div>
                </div>

                <div class="form-group col-md-12">
                    <label for="exampleInputUsername1">
                        Select User(s)
                    </label>
                    <div class="row col-md-12">
                        @Html.DropDownListFor(n => n.ListOfUsers, Enumerable.Empty<SelectListItem>(), "Please select Question", new { @class = "form-control select2 col-md-12", @id = "selectUser", @multiple = "multiple" })
                        @Html.ValidationMessageFor(model => model.ListOfUsers, null, new { @class = "text text-danger" })
                    </div>
                </div>


                <button type="submit" class="btn btn-primary mr-2">Add User(s) for Assessment</button>
            </div>
                }

            </div>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-md-12 grid-margin stretch-card">
        <div class="card tablecontainer">
            <div class="card-body">
                <h4 class="card-title"></h4>
                <p class="card-description">
                    List of Assessments
                </p>
                <div class="table-responsive pt-3">
                    <table class="table table-bordered table-info table-hover" id="myTable">
                        <thead class="table-dark text-center">
                            <tr>
                                <th>
                                    S/N
                                </th>
                                <th>
                                    AssessmentName
                                </th>
                                <th>
                                    StartDate
                                </th>
                                <th>
                                    EndDate
                                </th>
                                <th>
                                    User(s)
                                </th>
                                <th>
                                    Edit
                                </th>

                            </tr>
                        </thead>
                        <tbody></tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
<div id="UpdatePopup" class="modal fade">
    <div class="modal-dialog">
        <div class="modal-content" id="layout">

        </div>
    </div>
</div>

<script type="text/javascript">
    var oTable;
    var toastrChecker;
    $(document).ready(function () {
     
    dataTableLoader();        
            toastrFunction();
     
        var assessmentUrl = '@Url.Action("GetAllPeriod", "AssessmentScheduling")';
        var userURL = '@Url.Action("GetAllUsers", "AssessmentScheduling")';
        ajaxCall('#select2', assessmentUrl);
        ajaxCall('#selectUser', userURL);
       
    });


    //GetAllAssessments
    //GetAllUsers
    function ajaxCall(binder, url) {
            
        var pageSize = 20;
       $(binder).select2(
           {

                ajax: {
                    delay: 150,
                    url: url,
                    dataType: 'json',
                    data: function (params) {
                        params.page = params.page || 1;
                        return {
                            searchTerm: params.term,
                            pageSize: pageSize,
                            pageNumber: params.page
                        };
                    },
                    processResults: function (data, params) {
                        params.page = params.page || 1;
                        return {
                            results: data.Results,
                            pagination: {
                                more: (params.page * pageSize) < data.Total
                            }
                        };
                    }
                },
                placeholder: "-- Please select a name --",
                //minimumInputLength: 3,
                allowClear: true,

            });

    }






    function dataTableLoader() {
                    $("#myTable").dataTable().fnDestroy();
                     oTable = $("#myTable").DataTable({
                        //"processing": true, // for show progress bar
                        //"filter": true, // this is for disable filter (search box)
                        // "orderMulti": false, // for disable multiple column at once
                        // "serverSide": true,
                          "processing": true, // for show progress bar
                          "serverSide": true, // for process server side
                          "filter": true, // this is for disable filter (search box)
                          "orderMulti": false, // for disable multiple column at once
                         columns: [
                             {'data':'S/N',  render: function (data, type, full, meta) {

                              console.log("type", type)
                              console.log("full", full)
                              console.log("meta", meta.settings._iDisplayLength)
					 
					          console.log("_iDisplayStart", meta.settings._iDisplayStart)
				
                              var result = meta.row +1 +(meta.settings._iDisplayStart);
                      
                              return result;
                               }
                             },

                            { 'data': 'AssessmentName' },
                            { 'data': 'StartDateString',orderable: false },
                            { 'data': 'EndDateString',orderable: false },

                            {
                                'data': 'Users',orderable: false, render: function (data) {
                                    var records = data.map(function(author){return author.Username;}).join(", <br/> ");

                                    return '<h5>' + records+' </h5 > ';
                                }
                            },

                            {
                                "data": "Id", orderable: false, "width": "50px", render: function (data) {
                                    return '<a class="btn btn-success btn-lg pt-2 pb-2"  href="@Url.Action("Update", "AssessmentScheduling")?Id=' + data + '">Edit</a>';
                                }
                            }
                                
                        ],

                        "delay": 150,
                        "ajax": {
                            "url": '@Url.Action("GetAllRecords", "AssessmentScheduling")',
                            "type": "POST",
                            "datatype": "json"
                        }
                    });
                   return oTable;
                }

    function updateModal(userId) {
        $.get('@Url.Action("GetAssessmentConf", "AssessmentSetup")', { Id: userId }, function (res) {
            $("#layout").html(res);
            $("#UpdatePopup").modal("show"); 

        });
        }
    function UpdateAssessment() {
    var form = $('form[name="updateAss"]');
    var entry = form.serialize();
    $.get('@Url.Action("Edit", "AssessmentSetup")', entry, function (res) {
    console.log("Assessment Update", res);  
    if (res.data) {
    toastr.success(res.message, "Notification");
    oTable.ajax.reload();
    }
    else {
     toastr.error(res.message, "Notification");
        }
    });
    }
    function toastrFunction() {

        @*if ('@TempData["Check"]' == 'True') {
          toastr.success('@TempData["Message"]','Notification');
        }
        if ('@TempData["Check"]' == 'False') {
            toastr.error('@TempData["Message"]', 'Notification');
        }*@

         if ('@TempData["CreateCat"]'.length > 1) {
          toastr.success('@TempData["CreateCat"]','Notification');
         }
         else  if ('@TempData["Failed"]'.length>1) {
          toastr.error('@TempData["Failed"]','Notification');
         }


    }
</script>

